#include <stdlib.h>
#include <deco.h>
#include "minunit.h"
#include "p2_definitions.h"
#include "shared_definitions.h"

/*!
 * Test copying of deco schedule from OSTC internal data to deco library
 * structures on NDL.
 */
char *test_copy_no_stops() {
    deco_info_t *info = _copy_deco_stops();
    mu_assert("no stops test", info->n_stops == 0);
    mu_assert("no stops test", info->stops == NULL);
    return 0;
}

/*!
 * Test copying of deco schedule from OSTC internal data to deco library
 * structures with one deco stop.
 */
char *test_copy_one_stop() {
    deco_info_t *info;

    char_O_deco_depth[0] = 6;
    char_O_deco_time[0] = 3;
    char_O_deco_depth[1] = 0;
    char_O_deco_time[1] = 0;

    info = _copy_deco_stops();

    mu_assert("one stop test: n_stops", info->n_stops == 1);
    mu_assert("one stop test: depth", info->stops[0].depth == 6);
    mu_assert("one stop test: time", info->stops[0].time == 3);

    deco_free(NULL, NULL, info);
    return 0;
}


/*!
 * Test setting surface pressure.
 */
char *test_conf_set_pressure() {
    deco_conf_t *conf = deco_conf_new();

    conf->pressure = 980;
    _set_deco_params(conf);
    mu_assert("conf set pressure: 980", int_I_pres_surface == 980);

    conf->pressure = 1040;
    _set_deco_params(conf);
    mu_assert("conf set pressure: 1040", int_I_pres_surface == 1040);

    deco_free(NULL, conf, NULL);
    return 0;
}

